ARG SCANNER=trivy

FROM registry.access.redhat.com/ubi8/ruby-31 as builder
USER root
COPY . /gcs
WORKDIR /gcs
ENV PATH="/gcs/:${PATH}"
SHELL ["/bin/bash", "-c"]
RUN gem build gcs.gemspec -o gcs.gem

FROM registry.access.redhat.com/ubi8-minimal
USER root
ARG SCANNER
ENV SCANNER=${SCANNER}
ENV PATH="/home/gitlab:${PATH}"

COPY --from=ghcr.io/oras-project/oras:v0.12.0 /bin/oras /usr/local/bin/

COPY --from=builder /gcs/gcs.gem /gcs/script/setup.sh /gcs/script/.bashrc /gcs/version /home/gitlab/
COPY --from=builder /gcs/legal /home/gitlab/legal/
COPY --from=builder /gcs/ee/LICENSE /home/gitlab/ee/LICENSE

RUN microdnf update --nodocs && \
    microdnf module enable ruby:3.1 && \
    microdnf install ruby shadow-utils util-linux wget curl tar git --nodocs && \
    useradd gitlab -g root && \
    chown -R gitlab:root /home/gitlab/ && \
    chown gitlab /etc/pki/ && \
    chmod -R g+rw /etc/pki/ && \
    ln -s /home/gitlab/bin/gtcs /usr/bin/gtcs && \
    su - gitlab -c 'gem install --no-document /home/gitlab/gcs.gem' && \
    su - gitlab -c "export SCANNER=$SCANNER PATH="/home/gitlab:${PATH}"; cd /home/gitlab && bash setup.sh" && \
    microdnf remove shadow-utils wget && \
    microdnf clean all && \
    microdnf remove microdnf && \
    rm -f /usr/local/bin/oras

USER gitlab
ENV HOME "/home/gitlab"
# Ensures proper encoding when manipulating files
ENV LANG=C.utf8

# https://docs.openshift.com/container-platform/4.6/openshift_images/create-images.html#support-arbitrary-user-ids
RUN chgrp -R 0 /home/gitlab && \
    chmod -R g=u /home/gitlab

WORKDIR /home/gitlab
CMD ["gtcs", "scan"]
